/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Transaction transaction = new Transaction(commandData.Application.ActiveUIDocument.Document, "External Tool"); try { transaction.Start(); ElementSet elems = commandData.Application.ActiveUIDocument.Selection.Elements; #region selection error handle //if user have some wrong selection, give user an Error message if (1 != elems.Size) { message = "please select one PathReinforcement."; return(Autodesk.Revit.UI.Result.Cancelled); } Autodesk.Revit.DB.Element selectElem = null; foreach (Autodesk.Revit.DB.Element e in elems) { selectElem = e; } if (!(selectElem is Autodesk.Revit.DB.Structure.PathReinforcement)) { message = "please select one PathReinforcement."; return(Autodesk.Revit.UI.Result.Cancelled); } #endregion //clear all rebar bar type. if (s_rebarBarTypes.Count > 0) { s_rebarBarTypes.Clear(); } //get all bar type. FilteredElementCollector collector = new FilteredElementCollector(commandData.Application.ActiveUIDocument.Document); FilteredElementIterator itor = collector.OfClass(typeof(RebarBarType)).GetElementIterator(); itor.Reset(); while (itor.MoveNext()) { RebarBarType bartype = itor.Current as RebarBarType; if (null != bartype) { Autodesk.Revit.DB.ElementId id = bartype.Id; String name = bartype.Name; s_rebarBarTypes.Add(name, id); } } //Create a form to view the path reinforcement. Autodesk.Revit.DB.Structure.PathReinforcement pathRein = selectElem as Autodesk.Revit.DB.Structure.PathReinforcement; using (PathReinforcementForm form = new PathReinforcementForm(pathRein, commandData)) { form.ShowDialog(); } } catch (Exception e) { transaction.RollBack(); message = e.Message; return(Autodesk.Revit.UI.Result.Failed); } finally { transaction.Commit(); } return(Autodesk.Revit.UI.Result.Succeeded); }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Transaction transaction = new Transaction(commandData.Application.ActiveUIDocument.Document, "External Tool"); try { transaction.Start(); ElementSet elems = commandData.Application.ActiveUIDocument.Selection.Elements; #region selection error handle //if user have some wrong selection, give user an Error message if (1 != elems.Size) { message = "please select one PathReinforcement."; return Autodesk.Revit.UI.Result.Cancelled; } Autodesk.Revit.DB.Element selectElem = null; foreach (Autodesk.Revit.DB.Element e in elems) { selectElem = e; } if (!(selectElem is Autodesk.Revit.DB.Structure.PathReinforcement)) { message = "please select one PathReinforcement."; return Autodesk.Revit.UI.Result.Cancelled; } #endregion //clear all rebar bar type. if (s_rebarBarTypes.Count > 0) { s_rebarBarTypes.Clear(); } //get all bar type. FilteredElementCollector collector = new FilteredElementCollector(commandData.Application.ActiveUIDocument.Document); FilteredElementIterator itor = collector.OfClass(typeof(RebarBarType)).GetElementIterator(); itor.Reset(); while (itor.MoveNext()) { RebarBarType bartype = itor.Current as RebarBarType; if (null != bartype) { Autodesk.Revit.DB.ElementId id = bartype.Id; String name = bartype.Name; s_rebarBarTypes.Add(name, id); } } //Create a form to view the path reinforcement. Autodesk.Revit.DB.Structure.PathReinforcement pathRein = selectElem as Autodesk.Revit.DB.Structure.PathReinforcement; using (PathReinforcementForm form = new PathReinforcementForm(pathRein, commandData)) { form.ShowDialog(); } } catch (Exception e) { transaction.RollBack(); message = e.Message; return Autodesk.Revit.UI.Result.Failed; } finally { transaction.Commit(); } return Autodesk.Revit.UI.Result.Succeeded; }